<?php
namespace PME\Controllers\Parametrizacao;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class ComensaisEstimadosController extends \PME\Services\TeknisaCrud {
	protected $crudService;
	protected $parameterBag;
	protected $connection;

    public function __construct($crudService, $parameterBag, $connection) {
        parent::__construct($crudService, $parameterBag);
        $this->connection = $connection;
	}
	
	public function returnDadosComeservtcarComensais(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
		if (!empty($row['CDFILCENTPME'])) {
    		$query = "SELECT CDFILCENTPME, CDTIPOCARD, CDSERVFILI, CDFILIAL, QTCOMPMESEG, QTCOMPMETER, QTCOMPMEQUA, QTCOMPMEQUI, QTCOMPMESEX, QTCOMPMESAB, QTCOMPMEDOM, QTCOMPMEFER, QTCLIPMESEG, QTCLIPMETER, QTCLIPMEQUA, QTCLIPMEQUI, QTCLIPMESEX, QTCLIPMESAB, QTCLIPMEDOM, QTCLIPMEFER, QTFUNPMESEG, QTFUNPMETER, QTFUNPMEQUA, QTFUNPMEQUI, QTFUNPMESEX, QTFUNPMESAB, QTFUNPMEDOM, QTFUNPMEFER, QTDOAPMESEG, QTDOAPMETER, QTDOAPMEQUA, QTDOAPMEQUI, QTDOAPMESEX, QTDOAPMESAB, QTDOAPMEDOM, QTDOAPMEFER, QTMATRICULA, NRORG FROM COMESERVTCAR WHERE CDFILCENTPME = :P_CDFILCENTPME AND CDFILIAL = :P_CDFILIAL AND CDTIPOCARD = :P_CDTIPOCARD AND CDSERVFILI = :P_CDSERVFILI";
    		$params = array(
                "P_CDFILCENTPME" => $row["CDFILCENTPME"],
                "P_CDFILIAL"     => $row["CDFILIAL"],
                "P_CDTIPOCARD"   => $row["CDTIPOCARD"],
                "P_CDSERVFILI"   => $row["CDSERVFILI"]
            );
    		$stmt = $this->connection->prepare($query);
    		$stmt->execute($params);
            $result = $stmt->fetchAll();
    		$response->addDataSet(new DataSet("result", $result));
		}
	}
	
	public function save(DTO\Request $request, DTO\Response $response) {
        try{
            $row = $request->getRow();
            if($this->setValuesQtd($row)){
                if($row['__is_new'] === false) $query = "UPDATE COMESERVTCAR SET QTCOMPMESEG = :QTCOMPMESEG, QTCOMPMETER = :QTCOMPMETER, QTCOMPMEQUA = :QTCOMPMEQUA, QTCOMPMEQUI = :QTCOMPMEQUI, QTCOMPMESEX = :QTCOMPMESEX, QTCOMPMESAB = :QTCOMPMESAB, QTCOMPMEDOM = :QTCOMPMEDOM, QTCOMPMEFER = :QTCOMPMEFER, QTCLIPMESEG = :QTCLIPMESEG, QTCLIPMETER = :QTCLIPMETER, QTCLIPMEQUA = :QTCLIPMEQUA, QTCLIPMEQUI = :QTCLIPMEQUI, QTCLIPMESEX = :QTCLIPMESEX, QTCLIPMESAB = :QTCLIPMESAB, QTCLIPMEDOM = :QTCLIPMEDOM, QTCLIPMEFER = :QTCLIPMEFER, QTFUNPMESEG = :QTFUNPMESEG, QTFUNPMETER = :QTFUNPMETER, QTFUNPMEQUA = :QTFUNPMEQUA, QTFUNPMEQUI = :QTFUNPMEQUI, QTFUNPMESEX = :QTFUNPMESEX, QTFUNPMESAB = :QTFUNPMESAB, QTFUNPMEDOM = :QTFUNPMEDOM, QTFUNPMEFER = :QTFUNPMEFER, QTDOAPMESEG = :QTDOAPMESEG, QTDOAPMETER = :QTDOAPMETER, QTDOAPMEQUA = :QTDOAPMEQUA, QTDOAPMEQUI = :QTDOAPMEQUI, QTDOAPMESEX = :QTDOAPMESEX, QTDOAPMESAB = :QTDOAPMESAB, QTDOAPMEDOM = :QTDOAPMEDOM, QTDOAPMEFER = :QTDOAPMEFER, QTMATRICULA = :QTMATRICULA WHERE CDFILCENTPME = :CDFILCENTPME AND CDTIPOCARD = :CDTIPOCARD AND CDSERVFILI = :CDSERVFILI AND CDFILIAL = :CDFILIAL"; 
                else $query = "INSERT INTO COMESERVTCAR (CDFILCENTPME, CDTIPOCARD, CDSERVFILI, CDFILIAL, QTCOMPMESEG, QTCOMPMETER, QTCOMPMEQUA, QTCOMPMEQUI, QTCOMPMESEX, QTCOMPMESAB, QTCOMPMEDOM, QTCOMPMEFER, QTCLIPMESEG, QTCLIPMETER, QTCLIPMEQUA, QTCLIPMEQUI, QTCLIPMESEX, QTCLIPMESAB, QTCLIPMEDOM, QTCLIPMEFER, QTFUNPMESEG, QTFUNPMETER, QTFUNPMEQUA, QTFUNPMEQUI, QTFUNPMESEX, QTFUNPMESAB, QTFUNPMEDOM, QTFUNPMEFER, QTDOAPMESEG, QTDOAPMETER, QTDOAPMEQUA, QTDOAPMEQUI, QTDOAPMESEX, QTDOAPMESAB, QTDOAPMEDOM, QTDOAPMEFER, QTMATRICULA) VALUES (:CDFILCENTPME, :CDTIPOCARD, :CDSERVFILI, :CDFILIAL, :QTCOMPMESEG, :QTCOMPMETER, :QTCOMPMEQUA, :QTCOMPMEQUI, :QTCOMPMESEX, :QTCOMPMESAB, :QTCOMPMEDOM, :QTCOMPMEFER, :QTCLIPMESEG, :QTCLIPMETER, :QTCLIPMEQUA, :QTCLIPMEQUI, :QTCLIPMESEX, :QTCLIPMESAB, :QTCLIPMEDOM, :QTCLIPMEFER, :QTFUNPMESEG, :QTFUNPMETER, :QTFUNPMEQUA, :QTFUNPMEQUI, :QTFUNPMESEX, :QTFUNPMESAB, :QTFUNPMEDOM, :QTFUNPMEFER, :QTDOAPMESEG, :QTDOAPMETER, :QTDOAPMEQUA, :QTDOAPMEQUI, :QTDOAPMESEX, :QTDOAPMESAB, :QTDOAPMEDOM, :QTDOAPMEFER, :QTMATRICULA)";
                $this->connection->beginTransaction();
                $params = array(
                    "CDFILCENTPME" => $row["CDFILCENTPME"],
                    "CDFILIAL"     => $row["CDFILIAL"],
                    "CDTIPOCARD"   => $row["CDTIPOCARD"],
                    "CDSERVFILI"   => $row["CDSERVFILI"],
                    "QTCOMPMESEG"  => $row["QTCOMPMESEG"],
                    "QTCOMPMETER"  => $row["QTCOMPMETER"],
                    "QTCOMPMEQUA"  => $row["QTCOMPMEQUA"],
                    "QTCOMPMEQUI"  => $row["QTCOMPMEQUI"],
                    "QTCOMPMESEX"  => $row["QTCOMPMESEX"],
                    "QTCOMPMESAB"  => $row["QTCOMPMESAB"],
                    "QTCOMPMEDOM"  => $row["QTCOMPMEDOM"],
                    "QTCOMPMEFER"  => $row["QTCOMPMEFER"],
                    "QTCLIPMESEG"  => $row["QTCLIPMESEG"],
                    "QTCLIPMETER"  => $row["QTCLIPMETER"],
                    "QTCLIPMEQUA"  => $row["QTCLIPMEQUA"],
                    "QTCLIPMEQUI"  => $row["QTCLIPMEQUI"],
                    "QTCLIPMESEX"  => $row["QTCLIPMESEX"],
                    "QTCLIPMESAB"  => $row["QTCLIPMESAB"],
                    "QTCLIPMEDOM"  => $row["QTCLIPMEDOM"],
                    "QTCLIPMEFER"  => $row["QTCLIPMEFER"],
                    "QTFUNPMESEG"  => $row["QTFUNPMESEG"],
                    "QTFUNPMETER"  => $row["QTFUNPMETER"],
                    "QTFUNPMEQUA"  => $row["QTFUNPMEQUA"],
                    "QTFUNPMEQUI"  => $row["QTFUNPMEQUI"],
                    "QTFUNPMESEX"  => $row["QTFUNPMESEX"],
                    "QTFUNPMESAB"  => $row["QTFUNPMESAB"],
                    "QTFUNPMEDOM"  => $row["QTFUNPMEDOM"],
                    "QTFUNPMEFER"  => $row["QTFUNPMEFER"],
                    "QTDOAPMESEG"  => $row["QTDOAPMESEG"],
                    "QTDOAPMETER"  => $row["QTDOAPMETER"],
                    "QTDOAPMEQUA"  => $row["QTDOAPMEQUA"],
                    "QTDOAPMEQUI"  => $row["QTDOAPMEQUI"],
                    "QTDOAPMESEX"  => $row["QTDOAPMESEX"],
                    "QTDOAPMESAB"  => $row["QTDOAPMESAB"],
                    "QTDOAPMEDOM"  => $row["QTDOAPMEDOM"],
                    "QTDOAPMEFER"  => $row["QTDOAPMEFER"],
                    "QTMATRICULA"  => $row["QTMATRICULA"]
                );
                $stmt = $this->connection->prepare($query);
                $stmt->execute($params);
                $this->connection->commit();
                $response->addDataSet(new DataSet("save", array(true)));
            }
        } catch (\Exception $e) {
            $this->connection->rollback();
            $response->setError(new Error($e->getMessage(), 500));
        }
	}
	
	public function setValuesQtd ($row) {
	    if(empty($row['QTCOMPMESEG'])) $row["QTCOMPMESEG"] = 0;
        if(empty($row['QTCOMPMETER'])) $row["QTCOMPMETER"] = 0;
        if(empty($row['QTCOMPMEQUA'])) $row["QTCOMPMEQUA"] = 0;
        if(empty($row['QTCOMPMEQUI'])) $row["QTCOMPMEQUI"] = 0;
        if(empty($row['QTCOMPMESEX'])) $row["QTCOMPMESEX"] = 0;
        if(empty($row['QTCOMPMESAB'])) $row["QTCOMPMESAB"] = 0;
        if(empty($row['QTCOMPMEDOM'])) $row["QTCOMPMEDOM"] = 0;
        if(empty($row['QTCOMPMEFER'])) $row["QTCOMPMEFER"] = 0;
        if(empty($row['QTCLIPMESEG'])) $row["QTCLIPMESEG"] = 0;
        if(empty($row['QTCLIPMETER'])) $row["QTCLIPMETER"] = 0;
        if(empty($row['QTCLIPMEQUA'])) $row["QTCLIPMEQUA"] = 0;
        if(empty($row['QTCLIPMEQUI'])) $row["QTCLIPMEQUI"] = 0;
        if(empty($row['QTCLIPMESEX'])) $row["QTCLIPMESEX"] = 0;
        if(empty($row['QTCLIPMESAB'])) $row["QTCLIPMESAB"] = 0;
        if(empty($row['QTCLIPMEDOM'])) $row["QTCLIPMEDOM"] = 0;
        if(empty($row['QTCLIPMEFER'])) $row["QTCLIPMEFER"] = 0;
        if(empty($row['QTFUNPMESEG'])) $row["QTFUNPMESEG"] = 0;
        if(empty($row['QTFUNPMETER'])) $row["QTFUNPMETER"] = 0;
        if(empty($row['QTFUNPMEQUA'])) $row["QTFUNPMEQUA"] = 0;
        if(empty($row['QTFUNPMEQUI'])) $row["QTFUNPMEQUI"] = 0;
        if(empty($row['QTFUNPMESEX'])) $row["QTFUNPMESEX"] = 0;
        if(empty($row['QTFUNPMESAB'])) $row["QTFUNPMESAB"] = 0;
        if(empty($row['QTFUNPMEDOM'])) $row["QTFUNPMEDOM"] = 0;
        if(empty($row['QTFUNPMEFER'])) $row["QTFUNPMEFER"] = 0;
        if(empty($row['QTDOAPMESEG'])) $row["QTDOAPMESEG"] = 0;
        if(empty($row['QTDOAPMETER'])) $row["QTDOAPMETER"] = 0;
        if(empty($row['QTDOAPMEQUA'])) $row["QTDOAPMEQUA"] = 0;
        if(empty($row['QTDOAPMEQUI'])) $row["QTDOAPMEQUI"] = 0;
        if(empty($row['QTDOAPMESEX'])) $row["QTDOAPMESEX"] = 0;
        if(empty($row['QTDOAPMESAB'])) $row["QTDOAPMESAB"] = 0;
        if(empty($row['QTDOAPMEDOM'])) $row["QTDOAPMEDOM"] = 0;
        if(empty($row['QTDOAPMEFER'])) $row["QTDOAPMEFER"] = 0;
        if(empty($row['QTMATRICULA'])) $row["QTMATRICULA"] = 0;
        return $row;
	}
	
	public function returnDadosComeservtcarConsolidado(DTO\Request $request, DTO\Response $response) {
		$row = $request->getRow();
		$query = "SELECT CDFILCENTPME, CDTIPOCARD, CDSERVFILI, SUM(QTCOMPMESEG) QTCOMPMESEG, SUM(QTCOMPMETER) QTCOMPMETER, SUM(QTCOMPMEQUA) QTCOMPMEQUA, SUM(QTCOMPMEQUI) QTCOMPMEQUI, SUM(QTCOMPMESEX) QTCOMPMESEX, SUM(QTCOMPMESAB) QTCOMPMESAB, SUM(QTCOMPMEDOM) QTCOMPMEDOM, SUM(QTCOMPMEFER) QTCOMPMEFER, SUM(QTCLIPMESEG) QTCLIPMESEG, SUM(QTCLIPMETER) QTCLIPMETER, SUM(QTCLIPMEQUA) QTCLIPMEQUA, SUM(QTCLIPMEQUI) QTCLIPMEQUI, SUM(QTCLIPMESEX) QTCLIPMESEX, SUM(QTCLIPMESAB) QTCLIPMESAB, SUM(QTCLIPMEDOM) QTCLIPMEDOM, SUM(QTCLIPMEFER) QTCLIPMEFER, SUM(QTFUNPMESEG) QTFUNPMESEG, SUM(QTFUNPMETER) QTFUNPMETER, SUM(QTFUNPMEQUA) QTFUNPMEQUA, SUM(QTFUNPMEQUI) QTFUNPMEQUI, SUM(QTFUNPMESEX) QTFUNPMESEX, SUM(QTFUNPMESAB) QTFUNPMESAB, SUM(QTFUNPMEDOM) QTFUNPMEDOM, SUM(QTFUNPMEFER) QTFUNPMEFER, SUM(QTDOAPMESEG) QTDOAPMESEG, SUM(QTDOAPMETER) QTDOAPMETER, SUM(QTDOAPMEQUA) QTDOAPMEQUA, SUM(QTDOAPMEQUI) QTDOAPMEQUI, SUM(QTDOAPMESEX) QTDOAPMESEX, SUM(QTDOAPMESAB) QTDOAPMESAB, SUM(QTDOAPMEDOM) QTDOAPMEDOM, SUM(QTDOAPMEFER) QTDOAPMEFER, SUM(QTMATRICULA) QTMATRICULA FROM COMESERVTCAR WHERE CDFILCENTPME = :P_CDFILCENTPME AND CDTIPOCARD = :P_CDTIPOCARD AND CDSERVFILI = :P_CDSERVFILI GROUP BY CDFILCENTPME, CDTIPOCARD, CDSERVFILI";
		$params = array(
            "P_CDFILCENTPME" => $row["CDFILCENTPME"],
            "P_CDTIPOCARD"   => $row["CDTIPOCARD"],
            "P_CDSERVFILI"   => $row["CDSERVFILI"]
        );
		$stmt = $this->connection->prepare($query);
		$stmt->execute($params);
        $result = $stmt->fetchAll();
		$response->addDataSet(new DataSet("result", $result));
	}
}