<?php
/**
 * Created by PhpStorm.
 * User: phillipesilva
 * Date: 09/12/2014
 * Time: 10:59
 */

namespace Folha\Logic\FichaMedica;

use Folha\Entities\SstItemexame;
use Folha\Entities\SstItemexamefichamed;
use Geral\Util\Ambiente;
use HCM\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;

class Exame {
    public static function insertOrUpdateItensExame($nrExame, $nrExameFicha, $idInsUp)
    {
        $entityManager = Registry::getEntityManager();
        $db = $entityManager->getConnection();
        $db->beginTransaction();

        try {
            $cdOperador = Ambiente::getCdOperador();
            $dataAtual  = DateUtil::getDataAtual();
            $nrOrgTrab  = \FPA::getNrorgTrabalho();
            $nrOrgPadr  = \FPA::getNrorgPadrao();

            $where = "NREXAME = ?
                  AND (NRORG = ? OR NRORG = ?)";

            $params = array($nrExame, $nrOrgTrab, $nrOrgPadr);
            $itensExame = SstItemexame::getObjectsByWhere($where, $params);

            if($idInsUp == 'UPDATE') {
                self::deleteItensExame($nrExameFicha, $nrOrgTrab);
            }

            foreach($itensExame as $item) {
                $itemFicha = new SstItemexamefichamed();

                $itemFicha->setNritemexamefichamed(NovoCodigo::geraCodigo(Ambiente::getNrorg(), 'SST_ITEMEXAMEFICHAMED', 1));
                $itemFicha->setNrexamefichamed($nrExameFicha);
                $itemFicha->setNmitemexamefichamed($item->getNmitemexame());
                $itemFicha->setNritemexame($item->getNritemexame());
                $itemFicha->setIdocupacional('N');
                $itemFicha->setIdresultnormal('N');
                $itemFicha->setIdexamerefseq(null);
                $itemFicha->setIdativo('S');
                $itemFicha->setDtinclusao($dataAtual);
                $itemFicha->setDtultatu($dataAtual);
                $itemFicha->setCdoperinclusao($cdOperador);
                $itemFicha->setCdoperultatu($cdOperador);
                $itemFicha->setNrorg($nrOrgTrab);
                $itemFicha->setNrorginclusao($nrOrgTrab);
                $itemFicha->setNrorgultatu($nrOrgTrab);

                $itemFicha->persist();
            }

            $entityManager->flush();
            $db->commit();
        } catch (\Exception $e) {
            $db->rollback();
            throw $e;
        }
    }

    public static function callDeleteItensExame($nrExameFicha, $nrOrg)
    {
        $entityManager = Registry::getEntityManager();
        $db = $entityManager->getConnection();
        $db->beginTransaction();

        try {
            self::deleteItensExame($nrExameFicha, $nrOrg);

            $entityManager->flush();
            $db->commit();
        } catch (\Exception $e) {
            $db->rollback();
            throw $e;
        }
    }

    private static function deleteItensExame($nrExameFicha, $nrOrg)
    {
        $itensFicha = SstItemexamefichamed::findByNrexamefichamedAndNrorg($nrExameFicha, $nrOrg);

        foreach($itensFicha as $item) {
            $item->delete();
        }

        Registry::getEntityManager()->flush();
    }
} 