/*
-- ========================================================================== --
-- SISTEMA         : COMISSARIA                                               --
-- DATA DA CRIAO : INCIO - 12/09/2014                                      --
-- ========================================================================== --
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\1957_COCSTPO_IMPORT_PRECO_PRODUTOAP_COC.sql
-- ========================================================================== --
*/

create or replace 
PROCEDURE IMPORT_PRECO_PRODUTOAP_COC(
P_CDFILIAL     IN  ITLANCTOEST.CDFILIAL%TYPE,        
P_DATA         IN  ITLANCTOEST.DTLANCMOVI%TYPE,    
P_CDOPERADOR   IN  PRODUTOAP.CDOPIMPCUSTO%TYPE, 
P_ALMOXARIFADO IN  ITLANCTOEST.CDALMOXARIFE%TYPE,
P_LOCALIZACAO  IN  ITLANCTOEST.CDLOCALESTOQ%TYPE, 
P_NIVEL        IN  PRODUTO.CDNVPRODUTO%TYPE, 
P_CDPRODUTO    IN  PRODUTO.CDPRODUTO%TYPE)
IS 
V_VRCOMLIQ NUMBER; 
V_VRCOMBRU NUMBER; 
V_VRMEDLIQ NUMBER;
V_VRMEDBRU NUMBER;

BEGIN
   FOR C_PRODUTO IN(
      SELECT PR.CDPRODUTO, ROWNUM AS NRLINHA  
        FROM PRODUTO PR, PRODFILI PF
      WHERE (PR.CDNVPRODUTO   = P_NIVEL     )   AND
            (PR.CDPRODUTO     = PR.CDPRODESTO)   AND
            (PR.CDARVPROD  LIKE P_CDPRODUTO )   AND
            (PF.CDPRODUTO (+) = PR.CDPRODUTO)    AND
            (PF.IDPRODATIV(+) = 'A'         )    AND
            (PF.CDFILIAL  (+) = P_CDFILIAL  )   AND
            (PR.IDPRODCOMISS  IS NULL       )    AND
            NOT EXISTS(SELECT CDPRODUTO
                         FROM PRODUTOAP 
                       WHERE (CDFILIAL  = P_CDFILIAL)     AND
                             (DTCUSTOAP = P_DATA    )     AND
                             (CDPRODUTO = PR.CDPRODUTO))  
      )
   LOOP
      SELECT
         MAX(VRLANCTOEST ) VRCOMLIQ,
         MAX(VRLANCTOBRUT) VRCOMBRU
       INTO V_VRCOMLIQ, V_VRCOMBRU 
      FROM
         ITLANCTOEST IT
      WHERE
       (CDFILIMOVI   = P_CDFILIAL )         AND
       (CDPRODMOVI   = C_PRODUTO.CDPRODUTO) AND 
       (CDALMOXARIFE = P_ALMOXARIFADO)      AND
       (CDLOCALESTOQ = P_LOCALIZACAO)       AND
       (NRLOTEESTQ   = ' ' )                AND
       (NRSUBLOTE    = ' ' )                AND
       (IDTIPOMOVI   = '2' )                AND
       (DTLANCMOVI   = (SELECT
                         MAX(DTLANCMOVI)
                      FROM
                         ITLANCTOEST
                      WHERE
                         (CDFILIMOVI     = P_CDFILIAL )     AND
                         (CDALMOXARIFE   = P_ALMOXARIFADO)  AND
                         (CDLOCALESTOQ   = P_LOCALIZACAO)   AND
                         (NRLOTEESTQ     = ' ' )            AND
                         (NRSUBLOTE      = ' ' )            AND
                         (CDPRODUTO      = IT.CDPRODUTO)    AND
                         (IDTIPOMOVI     = '2')             AND
                         (DTLANCMOVI <=  P_DATA)));
    
       SELECT
          MAX(VRESTOQDIA /QTESTOQDIA) VRMEDLIQ,
          MAX(VRESTOQBRUT/QTESTOQDIA) VRMEDBRU
        INTO  V_VRMEDLIQ, V_VRMEDBRU
       FROM
        POSESTDIA PO
       WHERE
        (CDFILIAL      = P_CDFILIAL )          AND
        (CDPRODUTO     = C_PRODUTO.CDPRODUTO)  AND
        (CDALMOXARIFE  = P_ALMOXARIFADO)       AND
        (CDLOCALESTOQ  = P_LOCALIZACAO)        AND
        (NRLOTEESTQ    = ' ' )                 AND
        (NRSUBLOTE     = ' ' )                 AND
        (QTESTOQDIA<> 0      )                 AND
        (DTPOSIESTQ = (SELECT
                          MAX(DTPOSIESTQ)
                       FROM
                          POSESTDIA
                       WHERE
                          (CDFILIAL     = P_CDFILIAL )     AND
                          (CDALMOXARIFE = P_ALMOXARIFADO)  AND
                          (CDLOCALESTOQ = P_LOCALIZACAO)   AND
                          (NRLOTEESTQ   = ' ' )            AND
                          (NRSUBLOTE    = ' ' )            AND
                          (CDPRODUTO    = PO.CDPRODUTO)    AND
                          (QTESTOQDIA <> 0           )    AND
                          (DTPOSIESTQ <= P_DATA)));
                                                

        INSERT INTO PRODUTOAP
          (CDFILIAL   , DTCUSTOAP , CDPRODUTO , VRULTCLIQAP ,
          VRULTCBRUAP, VRMEDLIQAP, VRMEDBRUAP, DTHRIMPCUSTO,
          CDOPIMPCUSTO)
        VALUES(P_CDFILIAL, P_DATA, C_PRODUTO.CDPRODUTO,  NVL(V_VRCOMLIQ,0),
              NVL(V_VRCOMBRU,0), NVL(V_VRMEDLIQ,0), NVL(V_VRMEDBRU,0), SYSDATE, 
             P_CDOPERADOR); 
      
       IF MOD(C_PRODUTO.NRLINHA, 300) = 0 THEN
          COMMIT;   
       END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORT_PRECO_PRODUTOAP_COC','0.00.000'); END;
/
