package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;

public class RevisaoReceitasPMEPage extends PageBase {

    //Mapping
    By ClicarMenu = By.xpath("//i[@class='v-icon notranslate mdi mdi-menu theme--light']");
    By CampodePesquisa = By.id("menuSearchInput");
    By ClicarnaTelaPrato = By.xpath("//a[@id='5209739341401591282623']//div[@class='v-list-item__title']");

    By SetaParaSelecionarMenu = By.xpath("//i[@class='v-icon notranslate mdi mdi-chevron-down theme--light']");
    By SelecionarMenuRevisarReceita = By.xpath("//p[text()='Revisão de Receitas']");

    By CampoSelecionarReceitaOrigem = By.xpath("//input[@id='TPRECEITA']");
    By SelecionarReceitaServico = By.xpath("//div[@class='v-menu__content theme--light v-menu__content--fixed menuable__content__active v-autocomplete__content zd-select-menu zd-select-align-left zd-dense']//div[text()='Serviço']");
    By CampoSelecionarUnidadeOrigem = By.xpath("//input[@id='UNIDADE']");
    By SelecionarUnidadeOrigem = By.xpath("//div[text()='9999 | DEPOSITO BC 129']");
    By CampoSelecionarServicoOrigem = By.xpath("//input[@id='SERVICO']");
    By SelecionarServicoOrigem = By.xpath("//div[text()='00008 | ALMOÇO INFT']");
    By CampoSelecionarPratoInicial = By.xpath("//div[@id='PRATOINICIAL']//input");
    By CampoSelecionarPratoFinal = By.xpath("//div[@id='PRATOFINAL']//input");
    By SelecionarCheckPrato = By.xpath("//div[@id='gridPrato']//td[@class='zd-table-cell selectable']//div[@class='v-input zd-grid-row-checkbox v-input--hide-details theme--light v-input--selection-controls v-input--checkbox']");
    By InformarQuantidadePessoa = By.xpath("//div[@id='gridPrato']//td[@class='zd-table-cell text-left zd-table-column-editable zd-table-cell-editable']//span[@class='zd-table-cell-text']");
    By SalvarQuantidadeporPessoa = By.xpath("//div[@id='gridPrato-top']//button[@id='saveButton']");
    By CampoSelecionarReceitaDestino = By.xpath("//input[@id='TPRECEITADEST']");
    By SelecionarReceitaDestino = By.xpath("//div[@class='v-menu__content theme--light v-menu__content--fixed menuable__content__active v-autocomplete__content zd-select-menu zd-select-align-left zd-dense']//div[text()='Tipo de Cardápio']");
    By CampoSelecionarTipoCardapio = By.xpath("//input[@id='TIPOCARDDEST']");
    By SelecionarTipoCardapio = By.xpath("//div[text()='0000000002 | ALMOÇO INFANTIL']");

    By SelecionarReceitaDestinoLocal = By.xpath("//div[@class='v-menu__content theme--light v-menu__content--fixed menuable__content__active v-autocomplete__content zd-select-menu zd-select-align-left zd-dense']//div[text()='Local']");
    By CampoSelecionarUnidade = By.xpath("//input[@id='UNIDADEDEST']");
    By SelecionarUnidade = By.xpath("//div[@class='v-menu__content theme--light v-menu__content--fixed menuable__content__active v-autocomplete__content zd-select-menu zd-select-align-left zd-dense']//div[text()='9999 | DEPOSITO BC 129']");
    By ClicaremConfirmar = By.xpath("//button[@id='salvarRevisao']");



    //Actions
    public void AcessarTela() {
        tempo();
        click(ClicarMenu);
        sendKeys(CampodePesquisa, "Prato");
        tempo();
        click(ClicarnaTelaPrato);
    }

    public void TelaRevisarReceita(){
        tempo();
        click(SetaParaSelecionarMenu);
        click(SelecionarMenuRevisarReceita);
    }

    public void InformarDadosReceitaOrigem(){
        tempo();
        click(CampoSelecionarReceitaOrigem);
        click(SelecionarReceitaServico);
        click(CampoSelecionarUnidadeOrigem);
        tempo();
        click(SelecionarUnidadeOrigem);
        click(CampoSelecionarServicoOrigem);
        click(SelecionarServicoOrigem);
        click(CampoSelecionarPratoInicial);

    }

    public void PratoInicial(){
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(CampoSelecionarPratoInicial), 0, 100).click().build().perform();
        tempo();
    }

    public void PratoFinal(){
        tempo();
        click(CampoSelecionarPratoFinal);
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(CampoSelecionarPratoFinal), 0, 100).click().build().perform();
        tempo();
        tempo();
    }

    public void SelecionarPrato(){
        tempo();
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(SelecionarCheckPrato)).click().build().perform();
        tempo();
    }

    public void InformarQuantidadePessoa(){
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(InformarQuantidadePessoa)).click().build().perform();
        tempo();
        actions.sendKeys("2,21").build().perform();
        click(SalvarQuantidadeporPessoa);
    }

    public void InformarDestinoTipoCard(){
        tempo();
        click(CampoSelecionarReceitaDestino);
        click(SelecionarReceitaDestino);
        tempo();
        click(CampoSelecionarTipoCardapio);
        click(SelecionarTipoCardapio);
    }

    public void InformarDestinoLocal(){
        tempo();
        click(CampoSelecionarReceitaDestino);
        click(SelecionarReceitaDestinoLocal);
        click(CampoSelecionarUnidade);
        click(SelecionarUnidade);
    }

    public void Confirmar(){
        tempo();
        click(ClicaremConfirmar);
    }






}
